#include <bits/stdc++.h>

using namespace std;
long long mas[32005], mas1[32005];
vector<pair<long long, long long>> v;
int main()
{
  long long n;
  cin>>n;
  for(int i=0; i<n; i++)
  {
      cin>>mas[i];
      mas1[i] = mas[i];
  }
  sort(mas1, mas1+n);
  for(int i=0; i<n; i++)
  {
      if(mas1[i] != mas[i])
      {
          long long l=0;
          for(int j=i; j<n; j++)
           if(mas[j] == mas1[i])
          {
              l=j;
              break;
          }
          while(l!=i)
          {
              long long pos=0, m=0;
           for(int j=i; j<l; j++)
            if(m<mas[j])
           {
               m=mas[j];
               pos=j;
           }
          v.push_back(make_pair(pos, l));
          reverse(mas+pos, mas+l+1);
          l=pos;
          }

      }
  }

  cout<<v.size()<<'\n';
  for(int i=0; i<v.size(); i++)
    cout<<v[i].first+1<<' '<<v[i].second+1<<'\n';
}

